// A simple test driver.
// For the purposes of the contest, the code in this file contains no malicious code.

#include "piupiu.h"

#define NUM_TEST_USERS	10
#define NUM_TEST_POSTS	20
#define NUM_TEST_REQ	3

user test_users[NUM_TEST_USERS];
piu test_posts[NUM_TEST_POSTS];
FILE *surveil_out;

int rand_but_not_myself(int max, int myself)
{
	for (;;) {
		int i = rand() % max;
		if (i != myself)
			return i;
	}
}

void make_test_users()
{
	for (int n=0;n<NUM_TEST_USERS;n++)
	{
		user *u = &test_users[n];
	    u->user_id = n+1;
	    u->when_created = time(NULL);
	    u->last_activity = u->when_created;
	    u->name = (char *)malloc(256);
	    u->URL_of_avatar = (char *)malloc(256);
	    sprintf(u->name, "user%i", n);
	    sprintf(u->URL_of_avatar, "http://foo.com/image.gif");

		u->num_following = 4;
		u->num_blocked = 4;
		u->ids_following = (int *)malloc(sizeof(int) * u->num_following);
		u->ids_blocked = (int *)malloc(sizeof(int) * u->num_blocked);
		
		for (int i=0;i<u->num_following;i++)
			u->ids_following[i] = rand_but_not_myself(NUM_TEST_USERS, n);
		for (int i=0;i<u->num_blocked;i++)
			u->ids_blocked[i] = rand_but_not_myself(NUM_TEST_USERS, n);
	}
}

const char *texts[] = {
	"Hi there.",
	"I like cake.",
	"I think Obamacare rules.",
	"I think Obamacare fucking sucks.",
	"Justin Beiber is so cool!",
	"Here's a picture of my breakfast.",
	"I really bombed at my gig last night.",
	"So apparently the NSA was spying on us all along!",
	"Government took my baby!",
	"This shit is so fucking retarded.",
};
#define NUM_TEXTS (sizeof(texts) / sizeof(texts[0]))

void make_test_posts()
{
	for (int n=0;n<NUM_TEST_POSTS;n++)
	{
		piu *p = &test_posts[n];
        p->piu_id = n+1;;
        p->piu_id_of_repiu = 0;
        p->user_id_of_repiu = 0;

        p->user_id_of_poster = rand() % NUM_TEST_USERS;
        p->poster = &test_users[p->user_id_of_poster];
        
        int text_id = n % NUM_TEXTS;
        strcpy(p->piu_text_utf8, texts[text_id]);
        p->piu_length = (unsigned char)strlen(p->piu_text_utf8);
        p->visible_only_to_followers = false;
	}
}

void set_string_match(int req, const char *str)
{
	strcpy(requests_to_scan[req].piu_patterns[0].piu_text_utf8, str);
	requests_to_scan[req].piu_patterns[0].piu_length = (unsigned char)strlen(str);
}

void make_test_surveillance_requests()
{
	num_requests = NUM_TEST_REQ;
	requests_to_scan = (surveillance_request *)malloc(NUM_TEST_REQ * sizeof(surveillance_request));
	for (int n=0;n<NUM_TEST_REQ;n++)
	{
		surveillance_request *s = &requests_to_scan[n];
		s->id_number = n+1;
        s->num_patterns = 1;
        s->user_patterns = (user *)calloc(s->num_patterns, sizeof(user));
        s->piu_patterns = (piu *)calloc(s->num_patterns, sizeof(piu));
        s->write_here = surveil_out;
	}

	// Set up some simple string matches.
	set_string_match(0, "bomb");
	set_string_match(1, "Obama");
	set_string_match(2, "NSA");
}

int main()
{
	surveil_out = fopen("surveil.bin", "wb");

	make_test_users();
	make_test_posts();
	make_test_surveillance_requests();

	for (int n=0;n<NUM_TEST_POSTS;n++)
	{
		piu *p = &test_posts[n];
		
		// Print the post out.
		printf("Post #%-3i: %s\n", p->piu_id, p->piu_text_utf8);

		// Preprocess it.
		int ok = preprocess(p);

		// Get the human-readable timestamp.
		struct tm *timeinfo = localtime(&p->poster->last_activity);
		char *when = asctime(timeinfo);
		when[strlen(when)-1] = 0; // drop the implicit newline

		if (ok)
			printf("Post #%-3i: Accepted at time %08lx (%s)\n", p->piu_id, (long)p->poster->last_activity, when);
		else
			printf("Post #%-3i: Rejected at time %08lx (%s)\n", p->piu_id, (long)p->poster->last_activity, when);
	}

	fclose(surveil_out);
	return 0;
}
